/* autostart-manager.c generated by valac 0.40.13, the Vala compiler
 * generated from autostart-manager.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/*
 * A simple class for manipulating autostarting Geary as a hidden application through a simple
 * desktop file at $HOME/.config/autostart/geary.desktop
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_AUTOSTART_MANAGER (autostart_manager_get_type ())
#define AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AUTOSTART_MANAGER, AutostartManager))
#define AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))
#define IS_AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AUTOSTART_MANAGER))
#define IS_AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AUTOSTART_MANAGER))
#define AUTOSTART_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))

typedef struct _AutostartManager AutostartManager;
typedef struct _AutostartManagerClass AutostartManagerClass;
typedef struct _AutostartManagerPrivate AutostartManagerPrivate;

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
enum  {
	AUTOSTART_MANAGER_0_PROPERTY,
	AUTOSTART_MANAGER_NUM_PROPERTIES
};
static GParamSpec* autostart_manager_properties[AUTOSTART_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AutostartManager {
	GObject parent_instance;
	AutostartManagerPrivate * priv;
};

struct _AutostartManagerClass {
	GObjectClass parent_class;
};

struct _AutostartManagerPrivate {
	GearyApplication* instance;
	GFile* startup_file;
};


static gpointer autostart_manager_parent_class = NULL;

GType autostart_manager_get_type (void) G_GNUC_CONST;
GType geary_application_get_type (void) G_GNUC_CONST;
#define AUTOSTART_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AUTOSTART_MANAGER, AutostartManagerPrivate))
#define AUTOSTART_MANAGER_AUTOSTART_FOLDER "autostart"
#define AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE "geary-autostart.desktop"
AutostartManager* autostart_manager_new (GearyApplication* instance);
AutostartManager* autostart_manager_construct (GType object_type,
                                               GearyApplication* instance);
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
Configuration* geary_application_get_config (GearyApplication* self);
GSettings* configuration_get_settings (Configuration* self);
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
void autostart_manager_on_startup_notification_change (AutostartManager* self);
static void _autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                           const gchar* key,
                                                                           gpointer self);
GFile* autostart_manager_get_autostart_desktop_file (AutostartManager* self);
GFile* geary_application_get_install_dir (GearyApplication* self);
#define GEARY_APPLICATION_SOURCE_ROOT_DIR _SOURCE_ROOT_DIR
void autostart_manager_delete_startup_file (AutostartManager* self);
void autostart_manager_create_startup_file (AutostartManager* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void autostart_manager_sync_with_config (AutostartManager* self);
void configuration_set_startup_notifications (Configuration* self,
                                              gboolean value);
static void autostart_manager_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                      const gchar* key,
                                                                      gpointer self)
{
	autostart_manager_on_startup_notification_change ((AutostartManager*) self);
}


AutostartManager*
autostart_manager_construct (GType object_type,
                             GearyApplication* instance)
{
	AutostartManager * self = NULL;
	GearyApplication* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GearyApplication* _tmp7_;
	Configuration* _tmp8_;
	Configuration* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
	g_return_val_if_fail (IS_GEARY_APPLICATION (instance), NULL);
	self = (AutostartManager*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (instance);
	_g_object_unref0 (self->priv->instance);
	self->priv->instance = _tmp0_;
	_tmp1_ = g_get_user_config_dir ();
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_get_child (_tmp3_, AUTOSTART_MANAGER_AUTOSTART_FOLDER);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_file_get_child (_tmp5_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
	_g_object_unref0 (self->priv->startup_file);
	self->priv->startup_file = _tmp6_;
	_g_object_unref0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	_tmp7_ = self->priv->instance;
	_tmp8_ = geary_application_get_config (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = configuration_get_settings (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat ("changed::", CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, NULL);
	g_signal_connect_object (_tmp11_, _tmp12_, (GCallback) _autostart_manager_on_startup_notification_change_g_settings_changed, self, 0);
	_g_free0 (_tmp12_);
	return self;
}


AutostartManager*
autostart_manager_new (GearyApplication* instance)
{
	return autostart_manager_construct (TYPE_AUTOSTART_MANAGER, instance);
}


/**
     * Returns the system-wide autostart desktop file
     */
GFile*
autostart_manager_get_autostart_desktop_file (AutostartManager* self)
{
	GFile* result = NULL;
	GFile* install_dir = NULL;
	GearyApplication* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* desktop_file = NULL;
	GFile* _tmp17_;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_;
	GFile* _tmp21_;
	g_return_val_if_fail (IS_AUTOSTART_MANAGER (self), NULL);
	_tmp0_ = self->priv->instance;
	_tmp1_ = geary_application_get_install_dir (_tmp0_);
	install_dir = _tmp1_;
	_tmp3_ = install_dir;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		_tmp4_ = install_dir;
		_tmp5_ = g_file_get_child (_tmp4_, "share");
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_get_child (_tmp6_, "applications");
		_tmp8_ = _tmp7_;
		_tmp9_ = g_file_get_child (_tmp8_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
		_g_object_unref0 (_tmp2_);
		_tmp2_ = _tmp9_;
		_g_object_unref0 (_tmp8_);
		_g_object_unref0 (_tmp6_);
	} else {
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		GFile* _tmp16_;
		_tmp10_ = g_file_new_for_path (GEARY_APPLICATION_SOURCE_ROOT_DIR);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_get_child (_tmp11_, "build");
		_tmp13_ = _tmp12_;
		_tmp14_ = g_file_get_child (_tmp13_, "desktop");
		_tmp15_ = _tmp14_;
		_tmp16_ = g_file_get_child (_tmp15_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
		_g_object_unref0 (_tmp2_);
		_tmp2_ = _tmp16_;
		_g_object_unref0 (_tmp15_);
		_g_object_unref0 (_tmp13_);
		_g_object_unref0 (_tmp11_);
	}
	_tmp17_ = _g_object_ref0 (_tmp2_);
	desktop_file = _tmp17_;
	_tmp19_ = desktop_file;
	if (g_file_query_exists (_tmp19_, NULL)) {
		GFile* _tmp20_;
		_tmp20_ = desktop_file;
		_tmp18_ = _tmp20_;
	} else {
		_tmp18_ = NULL;
	}
	_tmp21_ = _g_object_ref0 (_tmp18_);
	result = _tmp21_;
	_g_object_unref0 (desktop_file);
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (install_dir);
	return result;
}


/**
     * Deletes the desktop file from autostart directory.
     */
void
autostart_manager_delete_startup_file (AutostartManager* self)
{
	GFile* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
	_tmp0_ = self->priv->startup_file;
	if (g_file_query_exists (_tmp0_, NULL)) {
		{
			GFile* _tmp1_;
			_tmp1_ = self->priv->startup_file;
			g_file_delete (_tmp1_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch10_g_error;
			}
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = err;
			_tmp3_ = _tmp2_->message;
			g_message ("autostart-manager.vala:49: Failed to delete startup file: %s", _tmp3_);
			_g_error_free0 (err);
		}
		__finally10:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
     * Creates .desktop file in autostart directory (usually '$HOME/.config/autostart/') if no one exists.
     */
void
autostart_manager_create_startup_file (AutostartManager* self)
{
	GFile* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
	_tmp0_ = self->priv->startup_file;
	if (g_file_query_exists (_tmp0_, NULL)) {
		return;
	}
	{
		GFile* autostart_dir = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* autostart = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		_tmp1_ = self->priv->startup_file;
		_tmp2_ = g_file_get_parent (_tmp1_);
		autostart_dir = _tmp2_;
		_tmp3_ = autostart_dir;
		if (!g_file_query_exists (_tmp3_, NULL)) {
			GFile* _tmp4_;
			_tmp4_ = autostart_dir;
			g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (autostart_dir);
				goto __catch11_g_error;
			}
		}
		_tmp5_ = autostart_manager_get_autostart_desktop_file (self);
		autostart = _tmp5_;
		_tmp6_ = autostart;
		if (_tmp6_ == NULL) {
			g_message ("autostart-manager.vala:67: Autostart file is not installed!");
		} else {
			GFile* _tmp7_;
			GFile* _tmp8_;
			_tmp7_ = autostart;
			_tmp8_ = self->priv->startup_file;
			g_file_copy (_tmp7_, _tmp8_, 0, NULL, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (autostart);
				_g_object_unref0 (autostart_dir);
				goto __catch11_g_error;
			}
		}
		_g_object_unref0 (autostart);
		_g_object_unref0 (autostart_dir);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = err;
		_tmp10_ = _tmp9_->message;
		g_message ("autostart-manager.vala:72: Failed to create startup file: %s", _tmp10_);
		_g_error_free0 (err);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
     * Callback for startup notification option changes.
     */
void
autostart_manager_on_startup_notification_change (AutostartManager* self)
{
	GearyApplication* _tmp0_;
	Configuration* _tmp1_;
	Configuration* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
	_tmp0_ = self->priv->instance;
	_tmp1_ = geary_application_get_config (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = configuration_get_startup_notifications (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		autostart_manager_create_startup_file (self);
	} else {
		autostart_manager_delete_startup_file (self);
	}
}


void
autostart_manager_sync_with_config (AutostartManager* self)
{
	GearyApplication* _tmp0_;
	Configuration* _tmp1_;
	Configuration* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
	_tmp0_ = self->priv->instance;
	_tmp1_ = geary_application_get_config (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->startup_file;
	configuration_set_startup_notifications (_tmp2_, g_file_query_exists (_tmp3_, NULL));
}


static void
autostart_manager_class_init (AutostartManagerClass * klass)
{
	autostart_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AutostartManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = autostart_manager_finalize;
}


static void
autostart_manager_instance_init (AutostartManager * self)
{
	self->priv = AUTOSTART_MANAGER_GET_PRIVATE (self);
}


static void
autostart_manager_finalize (GObject * obj)
{
	AutostartManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AUTOSTART_MANAGER, AutostartManager);
	_g_object_unref0 (self->priv->instance);
	_g_object_unref0 (self->priv->startup_file);
	G_OBJECT_CLASS (autostart_manager_parent_class)->finalize (obj);
}


GType
autostart_manager_get_type (void)
{
	static volatile gsize autostart_manager_type_id__volatile = 0;
	if (g_once_init_enter (&autostart_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AutostartManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) autostart_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AutostartManager), 0, (GInstanceInitFunc) autostart_manager_instance_init, NULL };
		GType autostart_manager_type_id;
		autostart_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AutostartManager", &g_define_type_info, 0);
		g_once_init_leave (&autostart_manager_type_id__volatile, autostart_manager_type_id);
	}
	return autostart_manager_type_id__volatile;
}



