/* util-date.c generated by valac 0.40.13, the Vala compiler
 * generated from util-date.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>

typedef enum  {
	DATE_CLOCK_FORMAT_TWELVE_HOURS,
	DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	DATE_CLOCK_FORMAT_TOTAL
} DateClockFormat;


#define DATE_TYPE_CLOCK_FORMAT (date_clock_format_get_type ())
typedef enum  {
	DATE_COARSE_DATE_NOW,
	DATE_COARSE_DATE_MINUTES,
	DATE_COARSE_DATE_HOURS,
	DATE_COARSE_DATE_TODAY,
	DATE_COARSE_DATE_YESTERDAY,
	DATE_COARSE_DATE_THIS_WEEK,
	DATE_COARSE_DATE_THIS_YEAR,
	DATE_COARSE_DATE_YEARS,
	DATE_COARSE_DATE_FUTURE
} DateCoarseDate;


#define DATE_TYPE_COARSE_DATE (date_coarse_date_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))


extern gint date_init_count;
gint date_init_count = 0;
extern gchar** date_xlat_pretty_dates;
extern gint date_xlat_pretty_dates_length1;
gchar** date_xlat_pretty_dates = NULL;
gint date_xlat_pretty_dates_length1 = 0;
static gint _date_xlat_pretty_dates_size_ = 0;
extern gchar** date_xlat_pretty_verbose_dates;
extern gint date_xlat_pretty_verbose_dates_length1;
gchar** date_xlat_pretty_verbose_dates = NULL;
gint date_xlat_pretty_verbose_dates_length1 = 0;
static gint _date_xlat_pretty_verbose_dates_size_ = 0;
extern gchar* date_xlat_same_year;
gchar* date_xlat_same_year = NULL;
extern gchar* date_xlat_diff_year;
gchar* date_xlat_diff_year = NULL;

GType date_clock_format_get_type (void) G_GNUC_CONST;
gint date_clock_format_to_index (DateClockFormat self);
GType date_coarse_date_get_type (void) G_GNUC_CONST;
void date_init (void);
void date_terminate (void);
gboolean date_same_day (GDateTime* a,
                        GDateTime* b);
DateCoarseDate date_as_coarse_date (GDateTime* datetime,
                                    GDateTime* now,
                                    GTimeSpan diff);
gchar* date_pretty_print_coarse (DateCoarseDate coarse_date,
                                 DateClockFormat clock_format,
                                 GDateTime* datetime,
                                 GTimeSpan diff);
gchar* date_pretty_print (GDateTime* datetime,
                          DateClockFormat clock_format);
gchar* date_pretty_print_verbose (GDateTime* datetime,
                                  DateClockFormat clock_format);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


gint
date_clock_format_to_index (DateClockFormat self)
{
	gint result = 0;
	result = CLAMP ((gint) self, 0, (gint) (DATE_CLOCK_FORMAT_TOTAL - 1));
	return result;
}


GType
date_clock_format_get_type (void)
{
	static volatile gsize date_clock_format_type_id__volatile = 0;
	if (g_once_init_enter (&date_clock_format_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_CLOCK_FORMAT_TWELVE_HOURS, "DATE_CLOCK_FORMAT_TWELVE_HOURS", "twelve-hours"}, {DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS, "DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS", "twenty-four-hours"}, {DATE_CLOCK_FORMAT_LOCALE_DEFAULT, "DATE_CLOCK_FORMAT_LOCALE_DEFAULT", "locale-default"}, {DATE_CLOCK_FORMAT_TOTAL, "DATE_CLOCK_FORMAT_TOTAL", "total"}, {0, NULL, NULL}};
		GType date_clock_format_type_id;
		date_clock_format_type_id = g_enum_register_static ("DateClockFormat", values);
		g_once_init_leave (&date_clock_format_type_id__volatile, date_clock_format_type_id);
	}
	return date_clock_format_type_id__volatile;
}


GType
date_coarse_date_get_type (void)
{
	static volatile gsize date_coarse_date_type_id__volatile = 0;
	if (g_once_init_enter (&date_coarse_date_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_COARSE_DATE_NOW, "DATE_COARSE_DATE_NOW", "now"}, {DATE_COARSE_DATE_MINUTES, "DATE_COARSE_DATE_MINUTES", "minutes"}, {DATE_COARSE_DATE_HOURS, "DATE_COARSE_DATE_HOURS", "hours"}, {DATE_COARSE_DATE_TODAY, "DATE_COARSE_DATE_TODAY", "today"}, {DATE_COARSE_DATE_YESTERDAY, "DATE_COARSE_DATE_YESTERDAY", "yesterday"}, {DATE_COARSE_DATE_THIS_WEEK, "DATE_COARSE_DATE_THIS_WEEK", "this-week"}, {DATE_COARSE_DATE_THIS_YEAR, "DATE_COARSE_DATE_THIS_YEAR", "this-year"}, {DATE_COARSE_DATE_YEARS, "DATE_COARSE_DATE_YEARS", "years"}, {DATE_COARSE_DATE_FUTURE, "DATE_COARSE_DATE_FUTURE", "future"}, {0, NULL, NULL}};
		GType date_coarse_date_type_id;
		date_coarse_date_type_id = g_enum_register_static ("DateCoarseDate", values);
		g_once_init_leave (&date_coarse_date_type_id__volatile, date_coarse_date_type_id);
	}
	return date_coarse_date_type_id__volatile;
}


void
date_init (void)
{
	gint _tmp0_;
	gchar* messages_locale = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* time_locale = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* language_env = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp28_;
	_tmp0_ = date_init_count;
	date_init_count = _tmp0_ + 1;
	if (_tmp0_ != 0) {
		return;
	}
	_tmp1_ = setlocale (LC_MESSAGES, NULL);
	_tmp2_ = g_strdup (_tmp1_);
	messages_locale = _tmp2_;
	_tmp3_ = setlocale (LC_TIME, NULL);
	_tmp4_ = g_strdup (_tmp3_);
	time_locale = _tmp4_;
	_tmp5_ = g_getenv ("LANGUAGE");
	_tmp6_ = g_strdup (_tmp5_);
	language_env = _tmp6_;
	_tmp7_ = language_env;
	if (_tmp7_ != NULL) {
		g_unsetenv ("LANGUAGE");
	}
	_tmp8_ = time_locale;
	if (_tmp8_ != NULL) {
		const gchar* _tmp9_;
		_tmp9_ = time_locale;
		setlocale (LC_MESSAGES, _tmp9_);
	}
	_tmp10_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
	date_xlat_pretty_dates = _tmp10_;
	date_xlat_pretty_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
	_tmp11_ = date_xlat_pretty_dates;
	_tmp11__length1 = date_xlat_pretty_dates_length1;
	_tmp12_ = g_strdup (_ ("%l:%M %P"));
	_g_free0 (_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
	_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp12_;
	_tmp13_ = date_xlat_pretty_dates;
	_tmp13__length1 = date_xlat_pretty_dates_length1;
	_tmp14_ = g_strdup (_ ("%H:%M"));
	_g_free0 (_tmp13_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
	_tmp13_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp14_;
	_tmp15_ = date_xlat_pretty_dates;
	_tmp15__length1 = date_xlat_pretty_dates_length1;
	_tmp16_ = g_strdup (C_ ("Default clock format", "%l:%M %P"));
	_g_free0 (_tmp15_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
	_tmp15_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp16_;
	_tmp17_ = g_strdup (_ ("%b %-e"));
	_g_free0 (date_xlat_same_year);
	date_xlat_same_year = _tmp17_;
	_tmp18_ = g_strdup (_ ("%x"));
	_g_free0 (date_xlat_diff_year);
	date_xlat_diff_year = _tmp18_;
	_tmp19_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
	date_xlat_pretty_verbose_dates = _tmp19_;
	date_xlat_pretty_verbose_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
	_tmp20_ = date_xlat_pretty_verbose_dates;
	_tmp20__length1 = date_xlat_pretty_verbose_dates_length1;
	_tmp21_ = g_strdup (_ ("%B %-e, %Y %-l:%M %P"));
	_g_free0 (_tmp20_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
	_tmp20_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp21_;
	_tmp22_ = date_xlat_pretty_verbose_dates;
	_tmp22__length1 = date_xlat_pretty_verbose_dates_length1;
	_tmp23_ = g_strdup (_ ("%B %-e, %Y %-H:%M"));
	_g_free0 (_tmp22_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
	_tmp22_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp23_;
	_tmp24_ = date_xlat_pretty_verbose_dates;
	_tmp24__length1 = date_xlat_pretty_verbose_dates_length1;
	_tmp25_ = g_strdup (C_ ("Default full date", "%B %-e, %Y %-l:%M %P"));
	_g_free0 (_tmp24_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
	_tmp24_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp25_;
	_tmp26_ = messages_locale;
	if (_tmp26_ != NULL) {
		const gchar* _tmp27_;
		_tmp27_ = messages_locale;
		setlocale (LC_MESSAGES, _tmp27_);
	}
	_tmp28_ = language_env;
	if (_tmp28_ != NULL) {
		const gchar* _tmp29_;
		_tmp29_ = language_env;
		g_setenv ("LANGUAGE", _tmp29_, TRUE);
	}
	_g_free0 (language_env);
	_g_free0 (time_locale);
	_g_free0 (messages_locale);
}


void
date_terminate (void)
{
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = date_init_count;
	date_init_count = _tmp0_ - 1;
	_tmp1_ = date_init_count;
	if (_tmp1_ != 0) {
		return;
	}
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
	date_xlat_pretty_dates = NULL;
	date_xlat_pretty_dates_length1 = 0;
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
	_g_free0 (date_xlat_same_year);
	date_xlat_same_year = NULL;
	_g_free0 (date_xlat_diff_year);
	date_xlat_diff_year = NULL;
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
	date_xlat_pretty_verbose_dates = NULL;
	date_xlat_pretty_verbose_dates_length1 = 0;
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
}


gboolean
date_same_day (GDateTime* a,
               GDateTime* b)
{
	gboolean result = FALSE;
	gint year1 = 0;
	gint month1 = 0;
	gint day1 = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint year2 = 0;
	gint month2 = 0;
	gint day2 = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gint _tmp8_;
	gint _tmp9_;
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	g_date_time_get_ymd (a, &_tmp0_, &_tmp1_, &_tmp2_);
	year1 = _tmp0_;
	month1 = _tmp1_;
	day1 = _tmp2_;
	g_date_time_get_ymd (b, &_tmp3_, &_tmp4_, &_tmp5_);
	year2 = _tmp3_;
	month2 = _tmp4_;
	day2 = _tmp5_;
	_tmp8_ = year1;
	_tmp9_ = year2;
	if (_tmp8_ == _tmp9_) {
		gint _tmp10_;
		gint _tmp11_;
		_tmp10_ = month1;
		_tmp11_ = month2;
		_tmp7_ = _tmp10_ == _tmp11_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		gint _tmp12_;
		gint _tmp13_;
		_tmp12_ = day1;
		_tmp13_ = day2;
		_tmp6_ = _tmp12_ == _tmp13_;
	} else {
		_tmp6_ = FALSE;
	}
	result = _tmp6_;
	return result;
}


DateCoarseDate
date_as_coarse_date (GDateTime* datetime,
                     GDateTime* now,
                     GTimeSpan diff)
{
	DateCoarseDate result = 0;
	g_return_val_if_fail (datetime != NULL, 0);
	g_return_val_if_fail (now != NULL, 0);
	if (date_same_day (datetime, now)) {
		if (diff < G_TIME_SPAN_MINUTE) {
			result = DATE_COARSE_DATE_NOW;
			return result;
		}
		if (diff < G_TIME_SPAN_HOUR) {
			result = DATE_COARSE_DATE_MINUTES;
			return result;
		}
		if (diff < (12 * G_TIME_SPAN_HOUR)) {
			result = DATE_COARSE_DATE_HOURS;
			return result;
		}
		result = DATE_COARSE_DATE_TODAY;
		return result;
	} else {
		GDateTime* temp = NULL;
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GDateTime* _tmp4_;
		if (g_date_time_compare (datetime, now) > 0) {
			result = DATE_COARSE_DATE_FUTURE;
			return result;
		}
		_tmp0_ = g_date_time_add_days (datetime, 1);
		_g_date_time_unref0 (temp);
		temp = _tmp0_;
		_tmp1_ = temp;
		if (date_same_day (_tmp1_, now)) {
			result = DATE_COARSE_DATE_YESTERDAY;
			_g_date_time_unref0 (temp);
			return result;
		}
		_tmp2_ = g_date_time_add_days (datetime, 6);
		_g_date_time_unref0 (temp);
		temp = _tmp2_;
		_tmp4_ = temp;
		if (date_same_day (_tmp4_, now)) {
			_tmp3_ = TRUE;
		} else {
			GDateTime* _tmp5_;
			_tmp5_ = temp;
			_tmp3_ = g_date_time_compare (_tmp5_, now) >= 0;
		}
		if (_tmp3_) {
			result = DATE_COARSE_DATE_THIS_WEEK;
			_g_date_time_unref0 (temp);
			return result;
		}
		if (g_date_time_get_year (datetime) == g_date_time_get_year (now)) {
			result = DATE_COARSE_DATE_THIS_YEAR;
			_g_date_time_unref0 (temp);
			return result;
		} else {
			result = DATE_COARSE_DATE_YEARS;
			_g_date_time_unref0 (temp);
			return result;
		}
		_g_date_time_unref0 (temp);
	}
}


gchar*
date_pretty_print_coarse (DateCoarseDate coarse_date,
                          DateClockFormat clock_format,
                          GDateTime* datetime,
                          GTimeSpan diff)
{
	gchar* result = NULL;
	gchar* fmt = NULL;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	g_return_val_if_fail (datetime != NULL, NULL);
	switch (coarse_date) {
		case DATE_COARSE_DATE_NOW:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Now"));
			result = _tmp0_;
			_g_free0 (fmt);
			return result;
		}
		case DATE_COARSE_DATE_MINUTES:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup_printf (ngettext ("%dm ago", "%dm ago", (gulong) (diff / G_TIME_SPAN_MINUTE)), (gint) (diff / G_TIME_SPAN_MINUTE));
			result = _tmp1_;
			_g_free0 (fmt);
			return result;
		}
		case DATE_COARSE_DATE_HOURS:
		{
			gint rounded = 0;
			gint _tmp2_;
			gint _tmp3_;
			gchar* _tmp4_;
			rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
			_tmp2_ = rounded;
			_tmp3_ = rounded;
			_tmp4_ = g_strdup_printf (ngettext ("%dh ago", "%dh ago", (gulong) _tmp2_), _tmp3_);
			result = _tmp4_;
			_g_free0 (fmt);
			return result;
		}
		case DATE_COARSE_DATE_TODAY:
		{
			gchar** _tmp5_;
			gint _tmp5__length1;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp5_ = date_xlat_pretty_dates;
			_tmp5__length1 = date_xlat_pretty_dates_length1;
			_tmp6_ = _tmp5_[date_clock_format_to_index (clock_format)];
			_tmp7_ = g_strdup (_tmp6_);
			_g_free0 (fmt);
			fmt = _tmp7_;
			break;
		}
		case DATE_COARSE_DATE_YESTERDAY:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Yesterday"));
			result = _tmp8_;
			_g_free0 (fmt);
			return result;
		}
		case DATE_COARSE_DATE_THIS_WEEK:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("%A"));
			_g_free0 (fmt);
			fmt = _tmp9_;
			break;
		}
		case DATE_COARSE_DATE_THIS_YEAR:
		{
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = date_xlat_same_year;
			_tmp11_ = g_strdup (_tmp10_);
			_g_free0 (fmt);
			fmt = _tmp11_;
			break;
		}
		default:
		case DATE_COARSE_DATE_YEARS:
		case DATE_COARSE_DATE_FUTURE:
		{
			const gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp12_ = date_xlat_diff_year;
			_tmp13_ = g_strdup (_tmp12_);
			_g_free0 (fmt);
			fmt = _tmp13_;
			break;
		}
	}
	_tmp14_ = fmt;
	_tmp15_ = g_date_time_format (datetime, _tmp14_);
	result = _tmp15_;
	_g_free0 (fmt);
	return result;
}


gchar*
date_pretty_print (GDateTime* datetime,
                   DateClockFormat clock_format)
{
	gchar* result = NULL;
	GDateTime* to_local = NULL;
	GDateTime* _tmp0_;
	GDateTime* now = NULL;
	GDateTime* _tmp1_;
	GTimeSpan diff = 0LL;
	gchar* _tmp2_;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = g_date_time_to_local (datetime);
	to_local = _tmp0_;
	_tmp1_ = g_date_time_new_now_local ();
	now = _tmp1_;
	diff = g_date_time_difference (now, to_local);
	_tmp2_ = date_pretty_print_coarse (date_as_coarse_date (to_local, now, diff), clock_format, to_local, diff);
	result = _tmp2_;
	_g_date_time_unref0 (now);
	_g_date_time_unref0 (to_local);
	return result;
}


gchar*
date_pretty_print_verbose (GDateTime* datetime,
                           DateClockFormat clock_format)
{
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = date_xlat_pretty_verbose_dates;
	_tmp0__length1 = date_xlat_pretty_verbose_dates_length1;
	_tmp1_ = _tmp0_[date_clock_format_to_index (clock_format)];
	_tmp2_ = g_date_time_format (datetime, _tmp1_);
	result = _tmp2_;
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



