/* util-email.c generated by valac 0.40.13, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



gint compare_conversation_ascending (GearyAppConversation* a,
                                     GearyAppConversation* b);
gint compare_conversation_descending (GearyAppConversation* a,
                                      GearyAppConversation* b);
gchar* email_util_strip_subject_prefixes (GearyEmail* email);
gchar* email_util_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);


gint
compare_conversation_ascending (GearyAppConversation* a,
                                GearyAppConversation* b)
{
	gint result = 0;
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	a_latest = _tmp0_;
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	b_latest = _tmp1_;
	_tmp2_ = a_latest;
	if (_tmp2_ == NULL) {
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
		_tmp4_ = b_latest;
		if (_tmp4_ == NULL) {
			_tmp3_ = 0;
		} else {
			_tmp3_ = -1;
		}
		result = _tmp3_;
		_g_object_unref0 (b_latest);
		_g_object_unref0 (a_latest);
		return result;
	} else {
		GearyEmail* _tmp5_;
		_tmp5_ = b_latest;
		if (_tmp5_ == NULL) {
			result = 1;
			_g_object_unref0 (b_latest);
			_g_object_unref0 (a_latest);
			return result;
		}
	}
	_tmp6_ = a_latest;
	_tmp7_ = b_latest;
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
	_g_object_unref0 (b_latest);
	_g_object_unref0 (a_latest);
	return result;
}


gint
compare_conversation_descending (GearyAppConversation* a,
                                 GearyAppConversation* b)
{
	gint result = 0;
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
	result = compare_conversation_ascending (b, a);
	return result;
}


gchar*
email_util_strip_subject_prefixes (GearyEmail* email)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
	_tmp1_ = geary_email_get_subject (email);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = geary_email_get_subject (email);
		_tmp4_ = _tmp3_;
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	_tmp6_ = g_strdup (_tmp0_);
	cleaned = _tmp6_;
	_tmp8_ = cleaned;
	if (!geary_string_is_empty (_tmp8_)) {
		const gchar* _tmp9_;
		_tmp9_ = cleaned;
		_tmp7_ = _tmp9_;
	} else {
		_tmp7_ = _ ("(no subject)");
	}
	_tmp10_ = g_strdup (_tmp7_);
	result = _tmp10_;
	_g_free0 (cleaned);
	_g_free0 (_tmp0_);
	return result;
}


/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
email_util_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESSES (mailboxes), NULL);
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("(No recipients)"));
		result = _tmp2_;
		return result;
	}
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
	_tmp4_ = _tmp3_;
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	first_recipient = _tmp6_;
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		result = first_recipient;
		return result;
	}
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp10_ = _tmp9_;
	_tmp11_ = first_recipient;
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
	result = _tmp14_;
	_g_free0 (first_recipient);
	return result;
}



