/* util-webkit.c generated by valac 0.40.13, the Vala compiler
 * generated from util-webkit.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include "geary-engine.h"
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))



gboolean web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                               GError** error);
gdouble web_kit_util_to_number (WebKitJavascriptResult* _result_,
                                GError** error);
gchar* web_kit_util_to_string (WebKitJavascriptResult* _result_,
                               GError** error);
gchar* web_kit_util_as_string (WebKitJavascriptResult* _result_,
                               GError** error);
struct OpaqueJSValue* web_kit_util_to_object (WebKitJavascriptResult* _result_,
                                              GError** error);


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `bool`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Boolean`.
     */
gboolean
web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                      GError** error)
{
	gboolean result = FALSE;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp0_;
	const struct OpaqueJSValue* value = NULL;
	const struct OpaqueJSValue* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	struct OpaqueJSContext* _tmp3_;
	const struct OpaqueJSValue* _tmp7_;
	struct OpaqueJSContext* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (_result_ != NULL, FALSE);
	_tmp0_ = webkit_javascript_result_get_global_context (_result_);
	context = _tmp0_;
	_tmp1_ = webkit_javascript_result_get_value (_result_);
	value = _tmp1_;
	_tmp2_ = value;
	_tmp3_ = context;
	if (!JSValueIsBoolean ((const struct OpaqueJSContext*) _tmp3_, _tmp2_)) {
		GError* _tmp4_;
		_tmp4_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Result is not a JS Boolean object");
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == GEARY_JS_ERROR) {
			gboolean _tmp5_ = FALSE;
			g_propagate_error (error, _inner_error_);
			return _tmp5_;
		} else {
			gboolean _tmp6_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp6_;
		}
	}
	_tmp7_ = value;
	_tmp8_ = context;
	result = JSValueToBoolean ((const struct OpaqueJSContext*) _tmp8_, _tmp7_);
	return result;
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `double`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Number`.
     */
inline gdouble
web_kit_util_to_number (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (_result_ != NULL, 0.0);
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
	_tmp2_ = webkit_javascript_result_get_value (_result_);
	_tmp0_ = geary_js_to_number ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == GEARY_JS_ERROR) {
			gdouble _tmp3_ = -1.0;
			g_propagate_error (error, _inner_error_);
			return _tmp3_;
		} else {
			gdouble _tmp4_ = -1.0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp4_;
		}
	}
	result = _tmp0_;
	return result;
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a Vala {@link string}.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `String`.
     */
inline gchar*
web_kit_util_to_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (_result_ != NULL, NULL);
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
	_tmp2_ = webkit_javascript_result_get_value (_result_);
	_tmp3_ = geary_js_to_string ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	_g_free0 (_tmp0_);
	return result;
}


/**
     * Converts a WebKit {@link WebKit.JavascriptResult} to a {@link string}.
     *
     * Unlike the other `get_foo_result` methods, this will coax the
     * result to a string, effectively by calling the JavaScript
     * `toString()` method on it, and returning that value.
     */
gchar*
web_kit_util_as_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp0_;
	const struct OpaqueJSValue* js_str_value = NULL;
	const struct OpaqueJSValue* _tmp1_;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSString* js_str = NULL;
	const struct OpaqueJSValue* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (_result_ != NULL, NULL);
	_tmp0_ = webkit_javascript_result_get_global_context (_result_);
	context = _tmp0_;
	_tmp1_ = webkit_javascript_result_get_value (_result_);
	js_str_value = _tmp1_;
	err = NULL;
	_tmp3_ = JSValueToStringCopy ((const struct OpaqueJSContext*) context, js_str_value, &_tmp2_);
	_0 (err);
	err = _tmp2_;
	js_str = _tmp3_;
	_tmp4_ = err;
	geary_js_check_exception ((const struct OpaqueJSContext*) context, _tmp4_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_JSStringRelease0 (js_str);
			_0 (err);
			return NULL;
		} else {
			_JSStringRelease0 (js_str);
			_0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = geary_js_to_native_string (js_str);
	result = _tmp5_;
	_JSStringRelease0 (js_str);
	_0 (err);
	return result;
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as an Object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
struct OpaqueJSValue*
web_kit_util_to_object (WebKitJavascriptResult* _result_,
                        GError** error)
{
	struct OpaqueJSValue* result = NULL;
	struct OpaqueJSValue* _tmp0_ = NULL;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	struct OpaqueJSValue* _tmp3_;
	struct OpaqueJSValue* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (_result_ != NULL, NULL);
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
	_tmp2_ = webkit_javascript_result_get_value (_result_);
	_tmp3_ = geary_js_to_object ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	_0 (_tmp0_);
	return result;
}



