/* geary-logging.c generated by valac 0.40.13, the Vala compiler
 * generated from geary-logging.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#define _XOPEN_SOURCE

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>

typedef enum  {
	GEARY_LOGGING_FLAG_NONE = 0,
	GEARY_LOGGING_FLAG_NETWORK = 1 << 0,
	GEARY_LOGGING_FLAG_SERIALIZER = 1 << 1,
	GEARY_LOGGING_FLAG_REPLAY = 1 << 2,
	GEARY_LOGGING_FLAG_CONVERSATIONS = 1 << 3,
	GEARY_LOGGING_FLAG_PERIODIC = 1 << 4,
	GEARY_LOGGING_FLAG_SQL = 1 << 5,
	GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION = 1 << 6,
	GEARY_LOGGING_FLAG_DESERIALIZER = 1 << 7
} GearyLoggingFlag;


#define GEARY_LOGGING_TYPE_FLAG (geary_logging_flag_get_type ())
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))


extern gint geary_logging_init_count;
gint geary_logging_init_count = 0;
extern GearyLoggingFlag geary_logging_logging_flags;
GearyLoggingFlag geary_logging_logging_flags = GEARY_LOGGING_FLAG_NONE;
extern FILE* geary_logging_stream;
FILE* geary_logging_stream = NULL;
extern GTimer* geary_logging_entry_timer;
GTimer* geary_logging_entry_timer = NULL;

#define GEARY_LOGGING_DOMAIN "Geary"
GType geary_logging_flag_get_type (void) G_GNUC_CONST;
gboolean geary_logging_flag_is_all_set (GearyLoggingFlag self,
                                        GearyLoggingFlag flags);
gboolean geary_logging_flag_is_any_set (GearyLoggingFlag self,
                                        GearyLoggingFlag flags);
void geary_logging_init (void);
void geary_logging_set_flags (GearyLoggingFlag flags);
void geary_logging_enable_flags (GearyLoggingFlag flags);
void geary_logging_disable_flags (GearyLoggingFlag flags);
GearyLoggingFlag geary_logging_get_flags (void);
gboolean geary_logging_are_all_flags_set (GearyLoggingFlag flags);
void geary_logging_error (GearyLoggingFlag flags,
                          const gchar* fmt,
                          ...) G_GNUC_PRINTF(2,3);
void geary_logging_critical (GearyLoggingFlag flags,
                             const gchar* fmt,
                             ...) G_GNUC_PRINTF(2,3);
void geary_logging_warning (GearyLoggingFlag flags,
                            const gchar* fmt,
                            ...) G_GNUC_PRINTF(2,3);
void geary_logging_message (GearyLoggingFlag flags,
                            const gchar* fmt,
                            ...) G_GNUC_PRINTF(2,3);
void geary_logging_debug (GearyLoggingFlag flags,
                          const gchar* fmt,
                          ...) G_GNUC_PRINTF(2,3);
void geary_logging_log_to (FILE* stream);
void geary_logging_default_handler (const gchar* domain,
                                    GLogLevelFlags log_levels,
                                    const gchar* message);
gchar* geary_logging_to_prefix (GLogLevelFlags level);


inline gboolean
geary_logging_flag_is_all_set (GearyLoggingFlag self,
                               GearyLoggingFlag flags)
{
	gboolean result = FALSE;
	result = (flags & self) == flags;
	return result;
}


inline gboolean
geary_logging_flag_is_any_set (GearyLoggingFlag self,
                               GearyLoggingFlag flags)
{
	gboolean result = FALSE;
	result = (flags & self) != 0;
	return result;
}


GType
geary_logging_flag_get_type (void)
{
	static volatile gsize geary_logging_flag_type_id__volatile = 0;
	if (g_once_init_enter (&geary_logging_flag_type_id__volatile)) {
		static const GFlagsValue values[] = {{GEARY_LOGGING_FLAG_NONE, "GEARY_LOGGING_FLAG_NONE", "none"}, {GEARY_LOGGING_FLAG_NETWORK, "GEARY_LOGGING_FLAG_NETWORK", "network"}, {GEARY_LOGGING_FLAG_SERIALIZER, "GEARY_LOGGING_FLAG_SERIALIZER", "serializer"}, {GEARY_LOGGING_FLAG_REPLAY, "GEARY_LOGGING_FLAG_REPLAY", "replay"}, {GEARY_LOGGING_FLAG_CONVERSATIONS, "GEARY_LOGGING_FLAG_CONVERSATIONS", "conversations"}, {GEARY_LOGGING_FLAG_PERIODIC, "GEARY_LOGGING_FLAG_PERIODIC", "periodic"}, {GEARY_LOGGING_FLAG_SQL, "GEARY_LOGGING_FLAG_SQL", "sql"}, {GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION, "GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION", "folder-normalization"}, {GEARY_LOGGING_FLAG_DESERIALIZER, "GEARY_LOGGING_FLAG_DESERIALIZER", "deserializer"}, {0, NULL, NULL}};
		GType geary_logging_flag_type_id;
		geary_logging_flag_type_id = g_flags_register_static ("GearyLoggingFlag", values);
		g_once_init_leave (&geary_logging_flag_type_id__volatile, geary_logging_flag_type_id);
	}
	return geary_logging_flag_type_id__volatile;
}


/**
 * Must be called before ''any'' call to the Logging namespace.
 *
 * This will be initialized by the Engine when it's opened, but applications may want to set up
 * logging before that, in which case, call this directly.
 */
void
geary_logging_init (void)
{
	gint _tmp0_;
	GTimer* _tmp1_;
	_tmp0_ = geary_logging_init_count;
	geary_logging_init_count = _tmp0_ + 1;
	if (_tmp0_ != 0) {
		return;
	}
	_tmp1_ = g_timer_new ();
	_g_timer_destroy0 (geary_logging_entry_timer);
	geary_logging_entry_timer = _tmp1_;
}


/**
 * Replaces the current logging flags with flags.  Use Geary.Logging.Flag.NONE to clear all
 * logging flags.
 */
void
geary_logging_set_flags (GearyLoggingFlag flags)
{
	geary_logging_logging_flags = flags;
}


/**
 * Adds the supplied flags to the current logging flags without disturbing the others.
 */
void
geary_logging_enable_flags (GearyLoggingFlag flags)
{
	GearyLoggingFlag _tmp0_;
	_tmp0_ = geary_logging_logging_flags;
	geary_logging_logging_flags = _tmp0_ | flags;
}


/**
 * Removes the supplied flags from the current logging flags without disturbing the others.
 */
void
geary_logging_disable_flags (GearyLoggingFlag flags)
{
	GearyLoggingFlag _tmp0_;
	_tmp0_ = geary_logging_logging_flags;
	geary_logging_logging_flags = _tmp0_ & (~flags);
}


/**
 * Returns the current logging flags.
 */
GearyLoggingFlag
geary_logging_get_flags (void)
{
	GearyLoggingFlag result = 0;
	GearyLoggingFlag _tmp0_;
	_tmp0_ = geary_logging_logging_flags;
	result = _tmp0_;
	return result;
}


/**
 * Returns true if all the flag(s) are set.
 */
inline gboolean
geary_logging_are_all_flags_set (GearyLoggingFlag flags)
{
	gboolean result = FALSE;
	GearyLoggingFlag _tmp0_;
	_tmp0_ = geary_logging_logging_flags;
	result = geary_logging_flag_is_all_set (_tmp0_, flags);
	return result;
}


inline void
geary_logging_error (GearyLoggingFlag flags,
                     const gchar* fmt,
                     ...)
{
	GearyLoggingFlag _tmp0_;
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_logging_logging_flags;
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
		va_list _tmp1_ = {0};
		va_start (_tmp1_, fmt);
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_ERROR, fmt, _tmp1_);
		va_end (_tmp1_);
	}
}


inline void
geary_logging_critical (GearyLoggingFlag flags,
                        const gchar* fmt,
                        ...)
{
	GearyLoggingFlag _tmp0_;
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_logging_logging_flags;
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
		va_list _tmp1_ = {0};
		va_start (_tmp1_, fmt);
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_CRITICAL, fmt, _tmp1_);
		va_end (_tmp1_);
	}
}


inline void
geary_logging_warning (GearyLoggingFlag flags,
                       const gchar* fmt,
                       ...)
{
	GearyLoggingFlag _tmp0_;
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_logging_logging_flags;
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
		va_list _tmp1_ = {0};
		va_start (_tmp1_, fmt);
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_WARNING, fmt, _tmp1_);
		va_end (_tmp1_);
	}
}


inline void
geary_logging_message (GearyLoggingFlag flags,
                       const gchar* fmt,
                       ...)
{
	GearyLoggingFlag _tmp0_;
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_logging_logging_flags;
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
		va_list _tmp1_ = {0};
		va_start (_tmp1_, fmt);
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_MESSAGE, fmt, _tmp1_);
		va_end (_tmp1_);
	}
}


inline void
geary_logging_debug (GearyLoggingFlag flags,
                     const gchar* fmt,
                     ...)
{
	GearyLoggingFlag _tmp0_;
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_logging_logging_flags;
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
		va_list _tmp1_ = {0};
		va_start (_tmp1_, fmt);
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_DEBUG, fmt, _tmp1_);
		va_end (_tmp1_);
	}
}


/**
 * Registers a FileStream to receive all log output from the Engine, be it via the specialized
 * Logging calls (which use the topic-based {@link Flag} or GLib's standard issue
 * debug/message/error/etc. calls ... thus, calling this will also affect the Engine user's calls
 * to those functions.
 *
 * If stream is null, no logging occurs.  This is default.
 */
void
geary_logging_log_to (FILE* stream)
{
	geary_logging_stream = stream;
}


static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


void
geary_logging_default_handler (const gchar* domain,
                               GLogLevelFlags log_levels,
                               const gchar* message)
{
	FILE* out = NULL;
	FILE* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	FILE* _tmp4_;
	g_return_if_fail (message != NULL);
	_tmp0_ = geary_logging_stream;
	out = _tmp0_;
	_tmp4_ = out;
	if (_tmp4_ != NULL) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = (G_LOG_LEVEL_WARNING & log_levels) > 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = (G_LOG_LEVEL_CRITICAL & log_levels) > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (G_LOG_LEVEL_ERROR & log_levels) > 0;
	}
	if (_tmp1_) {
		FILE* _tmp5_;
		struct tm tm = {0};
		time_t _tmp7_;
		struct tm _tmp8_ = {0};
		const gchar* _tmp9_ = NULL;
		FILE* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		struct tm _tmp13_;
		gint _tmp14_;
		struct tm _tmp15_;
		gint _tmp16_;
		struct tm _tmp17_;
		gint _tmp18_;
		GTimer* _tmp19_;
		GTimer* _tmp20_;
		_tmp5_ = out;
		if (_tmp5_ == NULL) {
			FILE* _tmp6_;
			_tmp6_ = stderr;
			out = _tmp6_;
		}
		_tmp7_ = time (NULL);
		g_time_local (_tmp7_, &_tmp8_);
		tm = _tmp8_;
		_tmp9_ = domain;
		if (_tmp9_ == NULL) {
			_tmp9_ = "default";
		}
		_tmp10_ = out;
		_tmp11_ = geary_logging_to_prefix (log_levels);
		_tmp12_ = _tmp11_;
		_tmp13_ = tm;
		_tmp14_ = _tmp13_.tm_hour;
		_tmp15_ = tm;
		_tmp16_ = _tmp15_.tm_min;
		_tmp17_ = tm;
		_tmp18_ = _tmp17_.tm_sec;
		_tmp19_ = geary_logging_entry_timer;
		fprintf (_tmp10_, "%s %02d:%02d:%02d %lf %s: %s\n", _tmp12_, _tmp14_, _tmp16_, _tmp18_, g_timer_elapsed (_tmp19_, NULL), _tmp9_, message);
		_g_free0 (_tmp12_);
		_tmp20_ = geary_logging_entry_timer;
		g_timer_start (_tmp20_);
	}
}


inline gchar*
geary_logging_to_prefix (GLogLevelFlags level)
{
	gchar* result = NULL;
	switch (level) {
		case G_LOG_LEVEL_ERROR:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("![err]");
			result = _tmp0_;
			return result;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("![crt]");
			result = _tmp1_;
			return result;
		}
		case G_LOG_LEVEL_WARNING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("*[wrn]");
			result = _tmp2_;
			return result;
		}
		case G_LOG_LEVEL_MESSAGE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (" [msg]");
			result = _tmp3_;
			return result;
		}
		case G_LOG_LEVEL_INFO:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (" [inf]");
			result = _tmp4_;
			return result;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (" [deb]");
			result = _tmp5_;
			return result;
		}
		case G_LOG_LEVEL_MASK:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("![***]");
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("![???]");
			result = _tmp7_;
			return result;
		}
	}
}



