/* memory-unowned-string-buffer.c generated by valac 0.40.13, the Vala compiler
 * generated from memory-unowned-string-buffer.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER (geary_memory_unowned_string_buffer_get_type ())
#define GEARY_MEMORY_UNOWNED_STRING_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER, GearyMemoryUnownedStringBuffer))
#define GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER))
#define GEARY_MEMORY_UNOWNED_STRING_BUFFER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER, GearyMemoryUnownedStringBufferIface))

typedef struct _GearyMemoryUnownedStringBuffer GearyMemoryUnownedStringBuffer;
typedef struct _GearyMemoryUnownedStringBufferIface GearyMemoryUnownedStringBufferIface;

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_MEMORY_TYPE_BUFFER (geary_memory_buffer_get_type ())
#define GEARY_MEMORY_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer))
#define GEARY_MEMORY_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))
#define GEARY_MEMORY_IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))

typedef struct _GearyMemoryBuffer GearyMemoryBuffer;
typedef struct _GearyMemoryBufferClass GearyMemoryBufferClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyMemoryUnownedStringBufferIface {
	GTypeInterface parent_iface;
	const gchar* (*to_unowned_string) (GearyMemoryUnownedStringBuffer* self);
	const gchar* (*get_unowned_valid_utf8) (GearyMemoryUnownedStringBuffer* self);
};



GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_memory_buffer_get_type (void) G_GNUC_CONST;
GType geary_memory_unowned_string_buffer_get_type (void) G_GNUC_CONST;
const gchar* geary_memory_unowned_string_buffer_to_unowned_string (GearyMemoryUnownedStringBuffer* self);
const gchar* geary_memory_unowned_string_buffer_get_unowned_valid_utf8 (GearyMemoryUnownedStringBuffer* self);
static const gchar* geary_memory_unowned_string_buffer_real_get_unowned_valid_utf8 (GearyMemoryUnownedStringBuffer* self);


/**
     * Returns an unowned string version of the backing buffer.
     *
     * The returned string should not be modified or freed.
     */
const gchar*
geary_memory_unowned_string_buffer_to_unowned_string (GearyMemoryUnownedStringBuffer* self)
{
	g_return_val_if_fail (GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER (self), NULL);
	return GEARY_MEMORY_UNOWNED_STRING_BUFFER_GET_INTERFACE (self)->to_unowned_string (self);
}


/**
     * An unowned version of {@link Memory.Buffer.get_valid_utf8}.
     */
static const gchar*
geary_memory_unowned_string_buffer_real_get_unowned_valid_utf8 (GearyMemoryUnownedStringBuffer* self)
{
	const gchar* result = NULL;
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	_tmp0_ = geary_memory_unowned_string_buffer_to_unowned_string (self);
	_tmp1_ = g_strdup (_tmp0_);
	str = _tmp1_;
	_tmp3_ = str;
	if (g_utf8_validate (_tmp3_, (gssize) -1, NULL)) {
		const gchar* _tmp4_;
		_tmp4_ = str;
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = "";
	}
	result = _tmp2_;
	_g_free0 (str);
	return result;
}


const gchar*
geary_memory_unowned_string_buffer_get_unowned_valid_utf8 (GearyMemoryUnownedStringBuffer* self)
{
	g_return_val_if_fail (GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER (self), NULL);
	return GEARY_MEMORY_UNOWNED_STRING_BUFFER_GET_INTERFACE (self)->get_unowned_valid_utf8 (self);
}


static void
geary_memory_unowned_string_buffer_default_init (GearyMemoryUnownedStringBufferIface * iface)
{
	iface->get_unowned_valid_utf8 = geary_memory_unowned_string_buffer_real_get_unowned_valid_utf8;
}


/**
 * Interface which allows access to backing string of {@link Memory.Buffer} without transferring
 * ownership, i.e. copying the string.
 *
 * The presence of this interface indicates that obtaining access to the backing string is cheap.
 *
 * Not all AbstractBuffers can support this call, but if they can, this interface allows for it.
 * The buffers that are returned should ''not'' be modified or freed by the caller.
 */
GType
geary_memory_unowned_string_buffer_get_type (void)
{
	static volatile gsize geary_memory_unowned_string_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&geary_memory_unowned_string_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyMemoryUnownedStringBufferIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_memory_unowned_string_buffer_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType geary_memory_unowned_string_buffer_type_id;
		geary_memory_unowned_string_buffer_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyMemoryUnownedStringBuffer", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (geary_memory_unowned_string_buffer_type_id, GEARY_MEMORY_TYPE_BUFFER);
		g_once_init_leave (&geary_memory_unowned_string_buffer_type_id__volatile, geary_memory_unowned_string_buffer_type_id);
	}
	return geary_memory_unowned_string_buffer_type_id__volatile;
}



