/* util-time.c generated by valac 0.40.13, the Vala compiler
 * generated from util-time.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <time.h>
#include <string.h>




time_t geary_time_datetime_to_time_t (GDateTime* datetime);
gint geary_numeric_int_floor (gint value,
                              gint floor);


/**
 * Converts a DateTime object into the nearest approximation of time_t.
 *
 * Since DateTime can store down to the microsecond and dates before UNIX epoch, there's some
 * truncating going on here.
 */
time_t
geary_time_datetime_to_time_t (GDateTime* datetime)
{
	time_t result = 0;
	struct tm tm = {0};
	gint _tmp0_ = 0;
	g_return_val_if_fail (datetime != NULL, 0);
	memset (&tm, 0, sizeof (struct tm));
	tm.tm_sec = g_date_time_get_second (datetime);
	tm.tm_min = g_date_time_get_minute (datetime);
	tm.tm_hour = g_date_time_get_hour (datetime);
	tm.tm_mday = g_date_time_get_day_of_month (datetime);
	tm.tm_mon = geary_numeric_int_floor (g_date_time_get_month (datetime) - 1, 0);
	tm.tm_year = geary_numeric_int_floor (g_date_time_get_year (datetime) - 1900, 0);
	if (g_date_time_is_daylight_savings (datetime)) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	tm.tm_isdst = _tmp0_;
	result = mktime (&tm);
	return result;
}



